/*
 * Copyright (C) 2014-2019 Igor Maznitsa
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.igormaznitsa.zxpoly.ui;

import com.igormaznitsa.z80.Utils;
import java.util.Locale;

public class AddressPanel extends javax.swing.JPanel {

  private static final long serialVersionUID = 7764500067541188353L;
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JLabel jLabel1;
  private javax.swing.JTextField textFieldAddress;

  public AddressPanel(final int address) {
    initComponents();
    this.textFieldAddress.setText(Utils.toHex(address & 0xFFFF));
  }

  public int extractAddressFromText() {
    final int addr;
    final String text = this.textFieldAddress.getText().trim().toUpperCase(Locale.ENGLISH);
    if (text.startsWith("$") || text.startsWith("#") || text.startsWith("0X")) {
      if (text.startsWith("0X")) {
        addr = Integer.parseInt(text.substring(2), 16);
      } else {
        addr = Integer.parseInt(text.substring(1), 16);
      }
    } else if (text.startsWith("&O")) {
      addr = Integer.parseInt(text.substring(2), 8);
    } else {
      addr = Integer.parseInt(text);
    }
    return addr;
  }

  /**
   * This method is called from within the constructor to initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is always
   * regenerated by the Form Editor.
   */
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {
    java.awt.GridBagConstraints gridBagConstraints;

    jLabel1 = new javax.swing.JLabel();
    textFieldAddress = new javax.swing.JTextField();

    setLayout(new java.awt.GridBagLayout());

    jLabel1.setText("Address (0-65535): ");
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 0);
    add(jLabel1, gridBagConstraints);
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 1;
    gridBagConstraints.gridy = 0;
    gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
    gridBagConstraints.ipadx = 100;
    gridBagConstraints.weightx = 1000.0;
    gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 5);
    add(textFieldAddress, gridBagConstraints);
  }// </editor-fold>//GEN-END:initComponents
  // End of variables declaration//GEN-END:variables

}
